<template>
  <q-page class="row flex-center background-login q-pa-lg">
    <q-dialog
      ref="passwordRecovery"
      v-model="passwordRecovery"
      :full-height="$q.screen.sm"
      :full-width="$q.screen.xs"
    >
      <q-card
        class="row flex-center bg-secondary"
        :style="styleCardRecovery"
      >
        <q-card-section class="col-12 text-center q-py-xl">
          <div
            class="text-bold text-primary"
            :class="$q.screen.sm || $q.screen.xs ? 'text-h5' : 'text-h4'"
          >
            Esqueceu sua senha?
          </div>
        </q-card-section>

        <q-card-section class="col-xl-7 col-lg-7 col-md-7 col-sm-10 col-xs-10 q-py-none">
          <q-input
            v-model="email"
            bg-color="white"
            color="primary"
            label="E-mail"
            bottom-slots
            autofocus
            outlined
            dense
            :error="$v.email.$error"
            @keyup.enter="recover({email})"
          >
            <template v-slot:error>
              <div
                v-for="(errorMessage, index) in errorMessages($v.email)"
                :key="index"
              >
                {{ errorMessage }}
              </div>
            </template>
          </q-input>
        </q-card-section>

        <q-card-section class="col-12 text-center q-pb-xl">
          <q-btn
            class="q-mb-sm"
            label="Recuperar minha senha"
            padding="12px 24px"
            color="primary"
            rounded
            @click="recover({email})"
          />
        </q-card-section>
      </q-card>
    </q-dialog>

    <q-card
      class="super-rounded-borders col-xl-3 col-lg-4 col-md-4 col-sm-8 col-xs-12"
      :style="styleCardLogin"
    >
      <q-card-section class="text-center q-pt-lg">
        <q-img
          src="~assets/logo.png"
          width="80%"
        />
      </q-card-section>

      <q-card-section class="row flex-center">
        <q-input
          v-model="form.email"
          class="col-10 q-px-md"
          label="E-mail"
          color="primary"
          bottom-slots
          autofocus
          outlined
          dense
          :error="$v.form.email.$error"
          @keyup.enter="$refs.password.focus()"
        >
          <template v-slot:error>
            <div
              v-for="(errorMessage, index) in errorMessages($v.form.email)"
              :key="index"
            >
              {{ errorMessage }}
            </div>
          </template>
        </q-input>

        <q-input
          ref="password"
          v-model="form.password"
          :type="isPwd ? 'password' : 'text'"
          class="col-10 q-px-md q-py-sm"
          label="Senha"
          color="primary"
          bottom-slots
          outlined
          dense
          :error="$v.form.password.$error"
          @keyup.enter="login(form)"
        >
          <template v-slot:append>
            <q-icon
              class="cursor-pointer"
              :name="isPwd ? 'visibility_off' : 'visibility'"
              @click="isPwd = !isPwd"
            />
          </template>

          <template v-slot:error>
            <div
              v-for="(errorMessage, index) in errorMessages($v.form.password)"
              :key="index"
            >
              {{ errorMessage }}
            </div>
          </template>
        </q-input>
      </q-card-section>

      <q-card-section class="row flex-center">
        <div class="col-10 q-px-md">
          <q-btn
            class="full-width"
            color="primary"
            label="Entrar"
            padding="12px"
            @click="login(form)"
          />
        </div>

        <div class="q-py-md">
          <q-btn
            color="primary"
            label="Esqueci minha senha"
            :ripple="false"
            no-wrap
            no-caps
            dense
            flat
            @click="passwordRecovery = true"
          />
        </div>
      </q-card-section>
    </q-card>
  </q-page>
</template>

<script>
import { ErrorMessagesMixin } from '../../mixin/error-messages'
import { required, email } from 'vuelidate/lib/validators'
import { UrlGoToMixin } from '../../mixin/url-go-to'

export default {
  name: 'PageLogin',
  mixins: [ErrorMessagesMixin, UrlGoToMixin],
  data () {
    return {
      form: {
        email: '',
        password: ''
      },
      passwordRecovery: false,
      email: '',
      isPwd: true
    }
  },
  validations: {
    form: {
      email: {
        required,
        email
      },
      password: {
        required
      }
    },
    email: {
      required,
      email
    }
  },
  computed: {
    styleCardLogin () {
      return {
        maxWidth: '500px'
      }
    },
    styleCardRecovery () {
      return {
        borderRadius: '10px',
        width: '50vw'
      }
    }
  },
  watch: {
    passwordRecovery () {
      this.email = ''
      this.$v.email.$reset()
    }
  },
  mounted () {
    this.urlGoTo()
  },
  methods: {
    async login (data) {
      this.$v.form.$touch()

      if (this.$v.form.$error) {
        return undefined
      }

      try {
        const axiosConfig = {
          method: 'POST',
          url: '/Usuarios/login',
          data
        }

        const query = await this.$axios(axiosConfig)
          .then(R => R.data)
          .then(({ userId, id: accessToken }) => ({ userId, accessToken }))

        this.$router.push({ path: '/auth/token', query })
      } catch (err) {
        this.axiosCatch(err)
      }
    },
    async recover (data) {
      this.$v.email.$touch()

      if (this.$v.email.$error) {
        return undefined
      }

      this.$q.loading.show()

      try {
        const axiosConfig = {
          method: 'POST',
          url: '/Usuarios/reset',
          data
        }

        await this.$axios(axiosConfig)

        this.axiosSuccess('Em breve você receberá um e-mail para recuperação da senha')
        this.$refs.passwordRecovery.hide()
      } catch (err) {
        this.axiosCatch(err)
      } finally {
        this.$q.loading.hide()
      }
    }
  }
}
</script>
